<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section v-if="computing">
            <div>
              <div
                class="column flex-center"
                style="height: 100%;"
              >
                <q-spinner
                  color=""
                  size="3em"
                />
                <translate>Computing Requaferti results...</translate>
              </div>
            </div>
          </q-card-section>

          <q-card-section v-else-if="requafertiError">
            <p>
              <translate>
                There were some errors while computing the Requaferti results: you may retry later.
              </translate>
            </p>
            <p
              v-html="requafertiError"
              class="text-negative"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                @click="onClickCompute"
                :disable="computing"
              >
                <translate>Retry</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { date } from 'quasar'
import proj4 from 'proj4'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryRequafertiComputeN from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiComputeN'
import { resultTypes, unitOfMeasures } from 'src/services/fieldbook/fertilization/fertilizationPlan'

// BELGE 72 / LAMBERT 72 PROJ
const EPSG_31370 = '+proj=lcc +lat_1=51.16666723333333 +lat_2=49.8333339 +lat_0=90 +lon_0=4.367486666666666 +x_0=150000.013 +y_0=5400088.438 +ellps=intl +towgs84=106.869,-52.2978,103.724,-0.33657,0.456955,-1.84218,1 +units=m +no_defs '

export default {
  name: 'RequafertiComputePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, DateMixin, AlgorithmsMixins],
  data () {
    return {
      requafertiError: null,
      computing: null,
      retryCount: 0
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Compute plan')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    storeParameters () {
      return this.$store.state.fertilizationPlan.parameters
    },
    storeTarget () {
      return this.$store.state.fertilizationPlan.target
    },
    computeNParams () {
      const params = {}
      // plot
      if (this.isParameterDefined(this.storeParameters.soilSampleDate)) {
        params.ech_date = date.formatDate(this.storeParameters.soilSampleDate, 'YYYY-MM-DD')
      } else {
        // default ech date is set in the future
        params.ech_date = '2099-01-01'
      }
      params.ech_num_ana = 'FaST-' + Date.now()
      params.ech_cp = null

      const [x, y] = this.storeTarget.centroid.coordinates
      const projXY = proj4(EPSG_31370, [x, y])
      params.ech_x = projXY[0]
      params.ech_y = projXY[1]

      // crop
      params.type_cult_xid = Number(this.storeParameters.cropProfile.id)
      if (this.storeParameters.cropVegetationStage) {
        params.stade_vege_xid = Number(this.storeParameters.cropVegetationStage.id)
      }
      if (this.storeParameters.cropSpinachHeight) {
        params.haut_epi_xid = Number(this.storeParameters.cropSpinachHeight.id)
      }
      if (this.storeParameters.cropColzaCoverage) {
        if (this.storeParameters.cropColzaCoverage.id === 'custom') {
          params.placette = Number(this.storeParameters.cropColzaCoverageCustom)
        } else {
          params.recouv_xid = Number(this.storeParameters.cropColzaCoverage.id)
        }
      }
      if (this.isParameterDefined(this.storeParameters.cropTargetYield)) {
        params.cult_obj_rend = Number(this.storeParameters.cropTargetYield)
      }

      // soil
      params.sol_cond_def_autres_yn = Boolean(this.storeParameters.soilConditionsAreUnfavorable)
      params.sol_nno3_profil = Number(this.storeParameters.soilNNO3Profile)
      if (this.isParameterDefined(this.storeParameters.soilNNH4Profile)) {
        params.sol_nnh4_profil = Number(this.storeParameters.soilNNH4Profile)
      }
      if (this.isParameterDefined(this.storeParameters.soilResidualN)) {
        params.sol_reliquat_n = Number(this.storeParameters.soilResidualN)
      }
      if (this.isParameterDefined(this.storeParameters.soilStonyContent)) {
        params.sol_cailloux = Number(this.storeParameters.soilStonyContent)
      }
      if (this.isParameterDefined(this.storeParameters.soilDensity)) {
        params.sol_densite = Number(this.storeParameters.soilDensity)
      }
      if (this.isParameterDefined(this.storeParameters.soilDepth)) {
        params.sol_couche_arable = Number(this.storeParameters.soilDepth)
      }
      if (this.isParameterDefined(this.storeParameters.soilAverageAirTemperature)) {
        params.sol_temp_air = Number(this.storeParameters.soilAverageAirTemperature)
      }
      params.sol_argile = Number(this.storeParameters.soilClayContent)
      if (this.isParameterDefined(this.storeParameters.soilCalciumContent)) {
        params.sol_calcaire = Number(this.storeParameters.soilCalciumContent)
      }
      if (this.isParameterDefined(this.storeParameters.soilOrganicMatterContent)) {
        params.sol_mo = Number(this.storeParameters.soilOrganicMatterContent)
      }
      if (this.isParameterDefined(this.storeParameters.soilCarbonContent)) {
        params.sol_carbone = Number(this.storeParameters.soilCarbonContent)
      }
      if (this.isParameterDefined(this.storeParameters.soilNHumus)) {
        params.sol_nhumus = Number(this.storeParameters.soilNHumus)
      }
      if (this.isParameterDefined(this.storeParameters.soilConversionFactor)) {
        params.sol_fact_conv = Number(this.storeParameters.soilConversionFactor)
      }
      if (this.isParameterDefined(this.storeParameters.soilKm)) {
        params.sol_km = Number(this.storeParameters.soilKm)
      }
      if (this.isParameterDefined(this.storeParameters.soilMineralizationPotential)) {
        params.sol_pot_mineral = Number(this.storeParameters.soilMineralizationPotential)
      }

      // previous crop
      if (this.storeParameters.previousCropExists) {
        params.type_cult_eff_prec_id = Number(this.storeParameters.previousCropProfile.id)
        params.dest_part_aer_id = Number(this.storeParameters.previousCropAerialPartDestination.part_aer_id)
        if (this.isParameterDefined(this.storeParameters.previousCropTestSampleIncludesNitrogenEffect)) {
          params.cult_eff_prec_yn = Boolean(this.storeParameters.previousCropTestSampleIncludesNitrogenEffect)
        } else {
          params.cult_eff_prec_yn = null
        }
      }

      // intermediate crop
      if (this.storeParameters.intermediateCropExists) {
        params.cult_inter_cipan = Number(this.storeParameters.intermediateCropProfile.id)
        params.type_prod_cipan = Number(this.storeParameters.intermediateCropProductionLevel.type_prod_xid)
        if (this.isParameterDefined(this.storeParameters.intermediateCropTestSampleIncludesNitrogenEffect)) {
          params.eff_cip_yn = Boolean(this.storeParameters.intermediateCropTestSampleIncludesNitrogenEffect)
        } else {
          params.eff_cip_yn = null
        }
      }

      if (this.storeParameters.intermediateCropHadMeadow) {
        params.age_prairie = Number(this.storeParameters.intermediateCropMeadowAge.id)
        params.period_destruct = Number(this.storeParameters.intermediateCropMeadowDestructionSeason.id)
        params.rang_culture = Number(this.storeParameters.intermediateCropMeadowRank.id)
      }

      if (this.storeParameters.intermediateCropHadLucerne) {
        params.age_luzerne = Number(this.storeParameters.intermediateCropLucerneAge.id)
        params.rang_luzerne = Number(this.storeParameters.intermediateCropLucerneRank.id)
      }

      // organic manure
      params.frequence_xid = Number(this.storeParameters.organicManureFrequency.id)
      if (this.storeParameters.organicManureApplications) {
        for (const [index, organicManureApplication] of this.storeParameters.organicManureApplications.entries()) {
          const appSuffix = `_app${index + 1}`
          params['cat_anim' + appSuffix] = Number(organicManureApplication.animalCategory.id)
          params['typ_mo' + appSuffix] = Number(organicManureApplication.organicMatterType.type_eff_xid)
          params['quantite_eff' + appSuffix] = Number(organicManureApplication.effluentQuantity)
          params['teneur_n' + appSuffix] = Number(organicManureApplication.nitrogenContent) || null
          params['date_app' + appSuffix] = date.formatDate(organicManureApplication.applicationDate, 'YYYY-MM-DD')
        }
      }

      return params
    }
  },
  mounted () {
    this.computeN('network-only')
  },
  methods: {
    onClickCompute () {
      this.computeN('network-only')
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiOrganicManure'
      })
    },
    isParameterDefined (param) {
      return param !== null && param !== undefined
    },
    async computeN (fetchPolicy) {
      try {
        this.computing = true
        this.retryCount += 1
        const { data } = await this.$apollo.query({
          query: queryRequafertiComputeN,
          variables: {
            params: this.computeNParams
          },
          fetchPolicy
        })
        const response = data?.requaferti__compute_n
        if (response?.fumure !== null) {
          const recommendations = [{
            chemical_element_id: 'N',
            quantity: response.besoin,
            result_type: resultTypes.PLANT_NEEDS,
            unit_of_measure_id: unitOfMeasures.KILOGRAM_PER_HECTARE
          }, {
            chemical_element_id: 'N',
            quantity: response.fournitures,
            result_type: resultTypes.PLANT_SUPPLIES,
            unit_of_measure_id: unitOfMeasures.KILOGRAM_PER_HECTARE
          }, {
            chemical_element_id: 'N',
            quantity: response.fumure,
            result_type: resultTypes.RECOMMENDATION,
            unit_of_measure_id: unitOfMeasures.KILOGRAM_PER_HECTARE
          }]
          const results = { recommendations }
          this.updateParameter('results', results)
          this.$router.replace({ name: 'requafertiResults' })
        } else {
          this.requafertiError = response?.error || 'Error: cannot display results'
          console.error('Requaferti results seem wrong', this.requafertiError)
        }
      } catch (e) {
        this.requafertiError = e
      } finally {
        this.computing = false
      }
    }
  }
}
</script>
